INSERT INTO RAKENNUS ( TUNNUS, NIMI, LYHYTNIMI, KATUOSOITE, POSTINUMERO,
KAUPUNKI ) VALUES (
'TKTLVALLILA', 'Tietojenksittelytieteenlaitos / Vallila', 'TKTLVALL', NULL, NULL, NULL); 
INSERT INTO RAKENNUS ( TUNNUS, NIMI, LYHYTNIMI, KATUOSOITE, POSTINUMERO,
KAUPUNKI ) VALUES ( 
'TKTLRUOHOL', 'Tietojenksittelytieteenlaitos / Ruoholahti', 'TKTLRUOH', NULL, NULL
, NULL); 

INSERT INTO KERROS ( RAKENN_TUNNUS, NUMERO ) VALUES ('TKTLVALLILA', 0); 
INSERT INTO KERROS ( RAKENN_TUNNUS, NUMERO ) VALUES ('TKTLVALLILA', 1); 
INSERT INTO KERROS ( RAKENN_TUNNUS, NUMERO ) VALUES ('TKTLVALLILA', 2); 
INSERT INTO KERROS ( RAKENN_TUNNUS, NUMERO ) VALUES ('TKTLVALLILA', 3); 
INSERT INTO KERROS ( RAKENN_TUNNUS, NUMERO ) VALUES ('TKTLVALLILA', 4); 
INSERT INTO KERROS ( RAKENN_TUNNUS, NUMERO ) VALUES ('TKTLVALLILA', 5); 
INSERT INTO KERROS ( RAKENN_TUNNUS, NUMERO ) VALUES ('TKTLVALLILA', 6); 
INSERT INTO KERROS ( RAKENN_TUNNUS, NUMERO ) VALUES ('TKTLVALLILA', 7); 


INSERT
  INTO rhuone (id, rakenn_tunnus, numero, kerros_numero, huone_nro, nimi, kuvaus)
(SELECT seq_rhuone_id.NEXTVAL, 'TKTLVALLILA', huone_nro, TO_NUMBER (SUBSTR (huone_nro, 2, 1)), huone_nro, NULL, NULL
  FROM huone
 WHERE huone_nro != 'HTC'
)
;


INSERT
  INTO puhelinnumero (id, rakenn_tunnus, puhelinnumero, lisayspvm)
(SELECT seq_puhnro_id.NEXTVAL, 'TKTLVALLILA', puhelin_tyo, SYSDATE
  FROM (SELECT DISTINCT puhelin_tyo AS puhelin_tyo
          FROM henkilo
         WHERE puhelin_tyo IS NOT NULL
       )
)
;

DECLARE
  CURSOR crs_henklot IS
      SELECT 'TKTLVALLILA' AS rakenn_tunnus, henklo.huone_nro, henklo.htunnus, rhuone.id AS rhuone_id
        FROM henkilo henklo
           , rhuone rhuone
       WHERE henklo.huone_nro IS NOT NULL
         AND henklo.huone_nro != 'HTC'
         AND rhuone.huone_nro = henklo.huone_nro
    ORDER BY 1, 2
  ;
  --
  --
  l_huone_nro           henkilo.huone_nro%TYPE       := '>!_!<';
  --l_count               PLS_INTEGER                 := 1;
  l_tpiste_id           tyopiste.id%TYPE;
BEGIN
  FOR c IN crs_henklot LOOP
    --IF (l_huone_nro != c.huone_nro) THEN
    --  l_count := 1;
    --  l_huone_nro := c.huone_nro;
    --END IF;
    --
    INSERT
      INTO tyopiste (id, rhuone_id, lisayspvm)
    VALUES (seq_tpiste_id.NEXTVAL, c.rhuone_id, SYSDATE)
    RETURNING id INTO l_tpiste_id
    ;
    --
    INSERT
      INTO henkilon_tyopiste (henklo_htunnus, tpiste_id, sijoituspvm)
    VALUES (c.htunnus, l_tpiste_id, SYSDATE)
    ;
    --
    --l_count := l_count + 1;
  END LOOP;
END;
/

INSERT
  INTO tyopistevaraus (id, tpiste_id, alkupvm, status, lisayspvm, henklo_htunnus)
       (SELECT seq_tpvara_id.NEXTVAL, tpiste_id, SYSDATE, 2, SYSDATE, henklo_htunnus
          FROM henkilon_tyopiste
       )
;


UPDATE tyopiste tpiste
   SET tpiste.puhnro_id = (
SELECT puhnro.id
  FROM henkilo henklo
     , puhelinnumero puhnro
     , henkilon_tyopiste hlotpi
 WHERE puhnro.rakenn_tunnus = 'TKTLVALLILA'
   AND henklo.puhelin_tyo = puhnro.puhelinnumero
   AND henklo.htunnus = hlotpi.henklo_htunnus
   AND hlotpi.tpiste_id = tpiste.id
)
;



DECLARE
  -- Generoi testi-HETU:t, perustuen SIIRTO_SOPIMUSJAKSO-taulun dataan.
  -- Olettaen, ett SIIRTO_SOPIMUSJAKSO on populoitu ensin.
  -- Hetut eivt mene oikein milln mittapuulla, mutta olkoon.
  CURSOR crs_henkilo IS
      SELECT htunnus
        FROM henkilo
       WHERE puhelin_tyo IS NOT NULL
      ;
  CURSOR crs_hetu IS
     SELECT DISTINCT henkilotunnus
       FROM siirto_sopimusjakso
       ;
  l_hetu                siirto_sopimusjakso.henkilotunnus%TYPE;
BEGIN
  OPEN crs_hetu;
  FOR c IN crs_henkilo LOOP
    FETCH crs_hetu INTO l_hetu;
    --
    UPDATE henkilo
       SET hetu = l_hetu
     WHERE henkilo.htunnus = c.htunnus;
  END LOOP;
  CLOSE crs_hetu;
END
;


COMMIT;
